package examples.dataloader;


import com.aliyun.odps.account.Account;
import com.aliyun.odps.account.AliyunAccount;
import com.aliyun.odps.data.Record;
import com.tzld.piaoquan.recommend.feature.domain.ad.base.AdActionFeature;
import com.tzld.piaoquan.recommend.feature.domain.ad.base.AdRequestContext;
import com.tzld.piaoquan.recommend.feature.domain.ad.base.UserAdFeature;
import com.tzld.piaoquan.recommend.feature.domain.ad.base.AdItemFeature;


import java.util.HashMap;
import java.util.Map;

public class AdSampleConstructor {

    private static final String BUCKET_NAME = "ali-recommend";
    private static final Map<String, String> ODPS_CONFIG = new HashMap<String, String>();

    static {
        ODPS_CONFIG.put("ENDPOINT", "http://service.cn.maxcompute.aliyun.com/api");
        ODPS_CONFIG.put("ACCESSID", "LTAIWYUujJAm7CbH");
        ODPS_CONFIG.put("ACCESSKEY", "RfSjdiWwED1sGFlsjXv0DlfTnZTG1P");
    }

    private static final Account account = new AliyunAccount(ODPS_CONFIG.get("ACCESSID"), ODPS_CONFIG.get("ACCESSKEY"));


    public static AdRequestContext constructRequestContext(Record record) {
        AdRequestContext requestContext = new AdRequestContext();
        requestContext.setApptype(record.getString("apptype"));
        requestContext.setMachineinfoBrand(record.getString("machineinfo_brand"));
        requestContext.setMachineinfoModel(record.getString("machineinfo_model"));
        requestContext.setMachineinfoSdkversion(record.getString("machineinfo_sdkversion"));
        requestContext.setMachineinfoWchatversion(record.getString("machineinfo_wechatversion"));


        requestContext.setDay(record.getString("ctx_day"));
        requestContext.setWeek(record.getString("ctx_week"));
        requestContext.setHour(record.getString("ctx_hour"));
        requestContext.setRegion(record.getString("province"));
        requestContext.setCity(record.getString("city"));
        return requestContext;
    }


    public static UserAdFeature constructUserFeature(Record record) {
        UserAdFeature userFeature = new UserAdFeature();
        userFeature.setMid(record.getString("machinecode"));

        // 1day features
        AdActionFeature user1dayActionFeature = new AdActionFeature();
        user1dayActionFeature.setOriginAdView(record.getString("user_view_1day"));
        user1dayActionFeature.setOriginAdClick(record.getString("user_click_1day"));
        user1dayActionFeature.setOriginAdConversion(record.getString("user_conversion_1day"));
        user1dayActionFeature.setOriginCtr(record.getString("user_ctr_1day"));
        user1dayActionFeature.setOriginCvr(record.getString("user_cvr_1day"));
        userFeature.setDay1_cnt_features(user1dayActionFeature);

        // 3day features
        AdActionFeature user3dayActionFeature = new AdActionFeature();
        user3dayActionFeature.setOriginAdView(record.getString("user_view_3day"));
        user3dayActionFeature.setOriginAdClick(record.getString("user_click_3day"));
        user3dayActionFeature.setOriginAdConversion(record.getString("user_conversion_3day"));
        user3dayActionFeature.setOriginCtr(record.getString("user_ctr_3day"));
        user3dayActionFeature.setOriginCvr(record.getString("user_cvr_3day"));
        userFeature.setDay3_cnt_features(user3dayActionFeature);


        // 7day features
        AdActionFeature user7dayActionFeature = new AdActionFeature();
        user7dayActionFeature.setOriginAdView(record.getString("user_view_7day"));
        user7dayActionFeature.setOriginAdClick(record.getString("user_click7day"));
        user7dayActionFeature.setOriginAdConversion(record.getString("user_conversion_7day"));
        user7dayActionFeature.setOriginCtr(record.getString("user_ctr_7day"));
        user7dayActionFeature.setOriginCvr(record.getString("user_cvr_7day"));
        userFeature.setDay7_cnt_features(user7dayActionFeature);

        // 3month features
        AdActionFeature user3MonthActionFeature = new AdActionFeature();
        user3MonthActionFeature.setOriginAdView(record.getString("user_view_3month"));
        user3MonthActionFeature.setOriginAdClick(record.getString("user_click_3month"));
        user3MonthActionFeature.setOriginAdConversion(record.getString("user_conversion_3month"));
        user3MonthActionFeature.setOriginCtr(record.getString("user_ctr_3month"));
        user3MonthActionFeature.setOriginCvr(record.getString("user_cvr_3month"));
        userFeature.setMonth3_cnt_features(user3MonthActionFeature);

        return userFeature;
    }


    public static AdItemFeature constructItemFeature(Record record) {
        AdItemFeature itemFeature = new AdItemFeature();


        itemFeature.setAdId(record.getString("adid"));
        // itemFeature.setAdCode(record.getString("adcode"));
        itemFeature.setAdvertiserId(record.getString("advertiserid"));
        itemFeature.setCampaignId(record.getString("campaignid"));
        itemFeature.setCreativeId(record.getString("creativeid"));

        // 1day features
        AdActionFeature user1dayActionFeature = new AdActionFeature();
        user1dayActionFeature.setOriginAdView(record.getString("ad_view_1day"));
        user1dayActionFeature.setOriginAdClick(record.getString("ad_click_1day"));
        user1dayActionFeature.setOriginAdConversion(record.getString("ad_conversion_1day"));
        user1dayActionFeature.setOriginCtr(record.getString("ad_ctr_1day"));
        user1dayActionFeature.setOriginCvr(record.getString("ad_cvr_1day"));
        itemFeature.setDay1_cnt_features(user1dayActionFeature);

        // 3day features
        AdActionFeature user3dayActionFeature = new AdActionFeature();
        user3dayActionFeature.setOriginAdView(record.getString("ad_view_3day"));
        user3dayActionFeature.setOriginAdClick(record.getString("ad_click_3day"));
        user3dayActionFeature.setOriginAdConversion(record.getString("ad_conversion_3day"));
        user3dayActionFeature.setOriginCtr(record.getString("ad_ctr_3day"));
        user3dayActionFeature.setOriginCvr(record.getString("ad_cvr_3day"));
        itemFeature.setDay3_cnt_features(user3dayActionFeature);


        // 7day features
        AdActionFeature user7dayActionFeature = new AdActionFeature();
        user7dayActionFeature.setOriginAdView(record.getString("ad_view_7day"));
        user7dayActionFeature.setOriginAdClick(record.getString("ad_click_7day"));
        user7dayActionFeature.setOriginAdConversion(record.getString("ad_conversion_7day"));
        user7dayActionFeature.setOriginCtr(record.getString("ad_ctr_7day"));
        user7dayActionFeature.setOriginCvr(record.getString("ad_cvr_7day"));
        itemFeature.setDay7_cnt_features(user7dayActionFeature);

        // 3month features
        AdActionFeature user3MonthActionFeature = new AdActionFeature();
        user3MonthActionFeature.setOriginAdView(record.getString("ad_view_3month"));
        user3MonthActionFeature.setOriginAdClick(record.getString("ad_click_3month"));
        user3MonthActionFeature.setOriginAdConversion(record.getString("ad_conversion_3month"));
        user3MonthActionFeature.setOriginCtr(record.getString("ad_ctr_3month"));
        user3MonthActionFeature.setOriginCvr(record.getString("ad_cvr_3month"));
        itemFeature.setMonth3_cnt_features(user3MonthActionFeature);


        //TODO  CREATIVE 维度  需要在样本中补齐
        AdActionFeature creative1dayFeature = new AdActionFeature();
        creative1dayFeature.setOriginAdView(record.getString("view_creative_1day"));
        creative1dayFeature.setOriginAdClick(record.getString("click_creative_1day"));
        creative1dayFeature.setOriginAdConversion(record.getString("conversion_creative_1day"));
        creative1dayFeature.setOriginCtr(record.getString("ctr_creative_1day"));
        creative1dayFeature.setOriginCvr(record.getString("cvr_creative_1day"));
        itemFeature.setCreative_1day_cnt_features(creative1dayFeature);

        // 3day features
        AdActionFeature creative3dayFeature = new AdActionFeature();
        creative3dayFeature.setOriginAdView(record.getString("view_creative_3day"));
        creative3dayFeature.setOriginAdClick(record.getString("click_creative_3day"));
        creative3dayFeature.setOriginAdConversion(record.getString("conversion_creative_3day"));
        creative3dayFeature.setOriginCtr(record.getString("ctr_creative_3day"));
        creative3dayFeature.setOriginCvr(record.getString("cvr_creative_3day"));
        itemFeature.setCreative_3day_cnt_features(creative3dayFeature);


        // 7day features
        AdActionFeature creative7dayFeature = new AdActionFeature();
        creative7dayFeature.setOriginAdView(record.getString("view_creative_7day"));
        creative7dayFeature.setOriginAdClick(record.getString("click_creative_7day"));
        creative7dayFeature.setOriginAdConversion(record.getString("conversion_creative_7day"));
        creative7dayFeature.setOriginCtr(record.getString("ctr_creative_7day"));
        creative7dayFeature.setOriginCvr(record.getString("cvr_creative_7day"));
        itemFeature.setCreative_7day_cnt_features(creative7dayFeature);

        // 3month features
        AdActionFeature creative3MonthFeature = new AdActionFeature();
        creative3MonthFeature.setOriginAdView(record.getString("view_creative_3month"));
        creative3MonthFeature.setOriginAdClick(record.getString("click_creative_3month"));
        creative3MonthFeature.setOriginAdConversion(record.getString("conversion_creative_3month"));
        creative3MonthFeature.setOriginCtr(record.getString("ctr_creative_3month"));
        creative3MonthFeature.setOriginCvr(record.getString("cvr_creative_3month"));
        itemFeature.setCreative_3month_cnt_features(creative3MonthFeature);


        // advertiser id
        // 1day features
        AdActionFeature advertiser1dayFeature = new AdActionFeature();
        advertiser1dayFeature.setOriginAdView(record.getString("advertiser_view_1day"));
        advertiser1dayFeature.setOriginAdClick(record.getString("advertiser_click_1day"));
        advertiser1dayFeature.setOriginAdConversion(record.getString("advertiser_conversion_1day"));
        advertiser1dayFeature.setOriginCtr(record.getString("advertiser_ctr_1day"));
        advertiser1dayFeature.setOriginCvr(record.getString("advertiser_cvr_1day"));
        itemFeature.setAdvertiser_1day_cnt_features(advertiser1dayFeature);

        // 3day features
        AdActionFeature advertiser3dayFeature = new AdActionFeature();
        advertiser3dayFeature.setOriginAdView(record.getString("advertiser_view_3day"));
        advertiser3dayFeature.setOriginAdClick(record.getString("advertiser_click_3day"));
        advertiser3dayFeature.setOriginAdConversion(record.getString("advertiser_conversion_3day"));
        advertiser3dayFeature.setOriginCtr(record.getString("advertiser_ctr_3day"));
        advertiser3dayFeature.setOriginCvr(record.getString("advertiser_cvr_3day"));
        itemFeature.setAdvertiser_3day_cnt_features(advertiser3dayFeature);


        // 7day features
        AdActionFeature advertiser7dayFeature = new AdActionFeature();
        advertiser7dayFeature.setOriginAdView(record.getString("advertiser_view_7day"));
        advertiser7dayFeature.setOriginAdClick(record.getString("advertiser_click_7day"));
        advertiser7dayFeature.setOriginAdConversion(record.getString("advertiser_conversion_7day"));
        advertiser7dayFeature.setOriginCtr(record.getString("advertiser_ctr_7day"));
        advertiser7dayFeature.setOriginCvr(record.getString("advertiser_cvr_7day"));
        itemFeature.setAdvertiser_7day_cnt_features(advertiser7dayFeature);

        // 3month features
        AdActionFeature advertiser3monthFeature = new AdActionFeature();
        advertiser3monthFeature.setOriginAdView(record.getString("advertiser_view_3month"));
        advertiser3monthFeature.setOriginAdClick(record.getString("advertiser_view_3month"));
        advertiser3monthFeature.setOriginAdConversion(record.getString("advertiser_conversion_3month"));
        advertiser3monthFeature.setOriginCtr(record.getString("advertiser_ctr_3month"));
        advertiser3monthFeature.setOriginCvr(record.getString("advertiser_cvr_3month"));
        itemFeature.setAdvertiser_3month_cnt_features(advertiser3monthFeature);



        return itemFeature;
    }


}
